// Semenov.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"


#include <stdlib.h>
#include <stdio.h>
#include <pthread.h>
#include <conio.h>
#include <time.h>
#include <md5.h>
#include <cstdlib>
#include <iostream>
#include <vector>
#include <string>

#include <Windows.h>
#include <Winbase.h>
 
#define N 6
using namespace std;

void integral_on_threads_main();
void philosophers_main();
double myrand(double n);

int main()
{    
      printf("Hellow World\n");
	  //integral_on_threads_main();
	  philosophers_main();


	  _getch();   
      return 0;
}   

//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
////////////////PHILOSOPHERS
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
CRITICAL_SECTION philosophers_spoons[N];

class spoon
{	
public:
	spoon(){isTaken = false;iOwnerID = -1;}
	bool isTaken;
	int iOwnerID;
};

struct philosopher_data
{
    spoon *spoons;
	int ID;
};

class philosopher
{
	public: 
		philosopher(philosopher_data* data){ID = data->ID; Spoons = data->spoons; want_eat = true; eats = 0;}

	int ID;
	spoon* Spoons;
	bool want_eat;
	int eats;

	void spoon_show()
	{
		//EnterCriticalSection(&philosophers_spoons[ID]);
		for(int i=0; i<N; i++)
		{
			if ((Spoons[i].iOwnerID == Spoons[(i+1) % N].iOwnerID)&&(Spoons[i].iOwnerID  != -1))
			{
				cout<<i<<" EAT ";//<<(i+1) % N;
			}
			else cout<<i<<" THINK ";//<<(i+1) % N;
		}
		cout<<endl;
		//LeaveCriticalSection(&philosophers_spoons[ID]);
	}

	bool eat(){
		int i;
		//cout<<Spoons[ID].isTaken<<endl;
		
		EnterCriticalSection(&philosophers_spoons[ID]);
		EnterCriticalSection(&philosophers_spoons[(ID+1) % N]);
		if (!Spoons[ID].isTaken && !Spoons[(ID+1) % N].isTaken)
		{
			start_eating();
			spoon_show();			
			double rnd = myrand(1000);
			Sleep(rnd);
			stop_eating();
			want_eat = false; eats++;
			LeaveCriticalSection(&philosophers_spoons[ID]);
			LeaveCriticalSection(&philosophers_spoons[(ID+1) % N]);
			return true;
		}
		else 
		{
			LeaveCriticalSection(&philosophers_spoons[ID]);
			LeaveCriticalSection(&philosophers_spoons[(ID+1) % N]);
			want_eat = true;
			return false;
		}	
	};
	void stop_eating(){
		Spoons[ID].isTaken = false;
		Spoons[ID].iOwnerID = -1;
		Spoons[(ID+1) % N].isTaken = false;
		Spoons[(ID+1) % N].iOwnerID = -1;
	};

	void start_eating(){
		Spoons[ID].isTaken = true;
		Spoons[(ID+1) % N].isTaken = true;
		Spoons[ID].iOwnerID = ID;
		Spoons[(ID+1) % N].iOwnerID = ID;
	};

	void run(){
		double rnd = myrand(100);
		if (rnd > 50 || want_eat)
			eat();
	};
};

void* philosopher_thread(void* args)
{
	philosopher phil((philosopher_data*) args);
	srand(int(time(NULL)) * (int)pthread_self().p);
	while(phil.eats<100)
		phil.run();

	return (void*)1;
}

void philosophers_main()
{
	pthread_t tid[N];	
	spoon *spoons = new spoon[N];


	philosopher_data Pdata[N];
	for(int i=0; i<N; i++)
	{		
		InitializeCriticalSection(&philosophers_spoons[i]);
		Pdata[i].ID = i;
		Pdata[i].spoons = spoons;
		
        pthread_create(&tid[i],NULL,philosopher_thread,&Pdata[i]);
	}

	for(int i=0; i<N; i++)
    {
	    int countout;
	    pthread_join(tid[i], (void **)&countout);
		DeleteCriticalSection(&philosophers_spoons[i]);
    }
}
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
////////////////INTEGRAL ON THREADS
//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
struct interval
{
    double a,b,h;
};

double x2(double x)
{
      return pow(x,2);
}

void* integral_on_threads_thread(void* args)
{
    interval* input = (interval*) args;
    double x, y;    
    int counter=0, k=0;
	srand(int(time(NULL)) * (int)pthread_self().p);
	while(k<1000)
	{
		x = input->a + myrand(input->b-input->a);
		y = myrand(input->h); //,pthread_self().p
		if(y<x2(x))
		{
		  counter++;
		}
		k++;		
	} 
    pthread_exit((void*) counter);   
	return (void*)counter;
}

void integral_on_threads_main()
{
      printf("Input a,b\n");
      double a,b;
	  cin >> a;	  cin >> b;	 

	  pthread_t tid[N];
      interval thread_input;
      thread_input.a = a;
      thread_input.b = b;
	  thread_input.h = x2(b);

      srand(time(NULL));
      for(int i=0; i<N; i++)
          pthread_create(&tid[i],NULL,integral_on_threads_thread,&thread_input);
        
      int countout=0, totalcount=0;   
      for(int i=0; i<N; i++)
      {
		  pthread_join(tid[i], (void **)&countout);
		  printf("%d\n",countout);
		  totalcount += countout;		  
      }
	  cout<<(b-a)*x2(b)*totalcount/(N*1000);	 
}

double myrand(double n) {
     return (double)(((double)rand()/(double)RAND_MAX)*n);
}
//////////////////////////////////////////////////////
////////////////////pass_on_threads_thread
//////////////////////////////////////////////////////
/*
void pass_on_threads_main()
{
	 
      unsigned char md5[MD5_DIGEST_LENGTH];
      unsigned char pass[5] = {'0','1','2','3','4'};
      cout<<pass<<"\n";
      MD5(pass,5,md5);  
      for(int i=0; i<MD5_DIGEST_LENGTH; i++)
  printf("%02x",md5[i]);
            
      pthread_t thread;
      pthread_create(&thread,NULL,pass_on_threads_thread,NULL);
      
       
      for(int i=0; i<36; i++)
      {
        string s;
        s.push_back(x[i]);
        buff_of_pass.push_back(s);
      }
     func(2);
     for(int i=0; i<10; i++)        
       cout<<buff_of_pass[i]<<endl;
      //MD5(pass,1,md5);
     // printf("%02x\n",md5);
       
      //cout<<md5;
}

void* pass_on_threads_thread(void* args)
{
   //unsigned char md5[MD5_DIGEST_LENGTH];
    char pass[5] = {'0','1','2','3','4'};     
   //MD5(pass,5,md5);  
   // for(int i=0; i<MD5_DIGEST_LENGTH; i++)
   //printf("%02x",md5[i]);
    //  cout<<md5(string(pass));
   // int counter=0;
   // pthread_exit((void*) counter);   
	return (void*)1;
}

vector<string> buff_of_pass;
char x[36];  
void init_x()
{   
   x[0]='a';
   for(int i=1; i<27; i++)
     x[i]=x[i-1]+1;
   x[26] = '0';
   for(int i=27; i<37; i++)
     x[i]=x[i-1]+1;
   x[36] = '\0';     
   //cout<<'\n'<<x<<'\n';     
}

void func(int count)
{
   if (count == 0) return;

      

   for(int i=0; i<buff_of_pass.size(); i++)
   {
     buff_of_pass[i].push_back(x[0]);
     for(int j=0; j<35; j++)
     {
       buff_of_pass.push_back(buff_of_pass[i]);
       buff_of_pass[i].operator[](count-2) = x[j];       
     }
   }
   func(count-1);
}
*/